package app.engine;

import app.window.MainPanel;
import java.awt.Graphics2D;

/**
 * @author Death
 */
public abstract class Game extends Engine{

    Screen screen;
    public MainPanel mainPanel;

    public Game(MainPanel panel){
        this.mainPanel = panel;
        screen = null;
    }
    
    public void setScreen(Screen s){
        if(screen != null) screen.dispose();
        s.game = this;
        s.init();
        s.initScreen(mainPanel);
        this.screen = s;
    }
    
    public Screen getScreen(){
        return this.screen;
    }
    
    @Override
    public void paint(Graphics2D g){
        if(screen != null) screen.paint(g);
    }

    @Override
    public void update(){
        if(screen != null) screen.update();
    }

    @Override
    public void keyLst(int key, int type){
        if(screen != null) screen.keyLst(key, type);
    }

    @Override
    public void mouseLst(int key, int type){
        if(screen != null) screen.mouseLst(key, type);
    }

    @Override
    public void wheelMouse(int r){
        if(screen != null) screen.wheelMouse(r);
    }

}
