package app.engine;

import app.SettingApp;
import app.window.MainPanel;
import java.awt.Color;
import java.awt.FlowLayout;
import javax.swing.JLabel;

/**
 * @author Death
 */
public abstract class Screen extends Engine{

    public WPanel panelGUI;
    public Game game;
    JLabel title;
    
    MainPanel mainPanel;

    public Screen(){
        panelGUI = new WPanel();
        title = null;
    }
    
    public void showTitle(String str){
        if(title == null){
            title = panelGUI.newLabel(str);
        }else{
            title.setText(str);
        }
        title.setForeground(new Color(0, 0, 0));
        title.setBackground(new Color(255, 255, 255));
        panelGUI.add(title, 0);
    }
    
    public void closeTitle(){
        if(title != null) panelGUI.remove(title);
        title = null;
    }
    
    void initScreen(MainPanel panel){
        this.mainPanel = panel;
        this.mainPanel.add(panelGUI);
        this.mainPanel.updateUI();
    }
    
    void dispose(){
        this.mainPanel.remove(panelGUI);
        this.mainPanel.updateUI();
    }
}
