package app.util;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.awt.image.WritableRaster;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.Random;
import javax.imageio.ImageIO;

/**
 * @author Death
 */
public class SM {

    static public Random random = new RandomXS128();

    /** Returns a random number between 0 (inclusive) and the specified value (inclusive). */
    static public int random (int range) {
            return random.nextInt(range + 1);
    }

    /** Returns a random number between start (inclusive) and end (inclusive). */
    static public int random (int start, int end) {
            return start + random.nextInt(end - start + 1);
    }

    /** Returns a random number between 0 (inclusive) and the specified value (inclusive). */
    static public long random (long range) {
            return (long)(random.nextDouble() * range);
    }

    /** Returns a random number between start (inclusive) and end (inclusive). */
    static public long random (long start, long end) {
            return start + (long)(random.nextDouble() * (end - start));
    }

    /** Returns a random boolean value. */
    static public boolean randomBoolean () {
            return random.nextBoolean();
    }

    /** Returns random number between 0.0 (inclusive) and 1.0 (exclusive). */
    static public float random () {
            return random.nextFloat();
    }

    /** Returns a random number between 0 (inclusive) and the specified value (exclusive). */
    static public float random (float range) {
            return random.nextFloat() * range;
    }

    /** Returns a random number between start (inclusive) and end (exclusive). */
    static public float random (float start, float end) {
            return start + random.nextFloat() * (end - start);
    }
        
    public static int random(int seed, int min, int max){
        return min + new Random(seed).nextInt(max - min + 1);
    } 
        
        
    public synchronized static BufferedImage setAlphaImage(BufferedImage image, int alpha){
        final int w = image.getWidth();
        final int h = image.getHeight();
        int[] pixel = new int[w * h];
        final int destAlpha = alpha << 24;
        for(int i = 0; i < pixel.length; i++){
            pixel[i] = destAlpha | (pixel[i] & 0xFFFFFF);
        }
        final BufferedImage result = new BufferedImage(w, h, BufferedImage.TYPE_INT_ARGB);
        final WritableRaster raster = (WritableRaster) result.getData();
        System.out.println("W: " + w + " H: " + h + " Len: " + pixel.length);
        raster.setPixels(0, 0, w, h, pixel);
        return result;
    }
    
    public static BufferedImage imgFile(String str){
        BufferedImage d = null;
        try {
            FileInputStream f = new FileInputStream(str);
            d = ImageIO.read(f);
        } catch (IOException ioe) {
            System.out.println("Не нашло \""+str + "\" Error: "+ioe);
        }
        return d;
    }
    
    public static BufferedImage resize(BufferedImage im, int w, int h){
        BufferedImage im1 = new BufferedImage(w, h, im.getType());
        Graphics2D g = im1.createGraphics();
        g.drawImage(im, 0, 0, w, h, null);
        g.dispose();
        return im1;
    }
    
    public static BufferedImage[] getArrayImage(BufferedImage im123, int wT, int hT){
        BufferedImage[] img;
        BufferedImage imageFile = im123;
        int wI = imageFile.getWidth();
        int hI = imageFile.getHeight();

        int kolXT = wI/wT;
        int kolYT = hI/hT;

        img = new BufferedImage[kolXT*kolYT + 1];
        int xT = 0;
        int yT = 0;
        img[0] = getImageNull(wT, hT);
        for(int i = 1; i < img.length; i++){

            img[i] = imageFile.getSubimage(xT, yT, wT, hT);
            xT += wT;
            if(xT > wI - wT){
                xT = 0;
                yT += hT;
            }
        }
        return img;
        
    }
    
    public static BufferedImage[] getArryaImage(String path, int wT, int hT){
        return getArrayImage(SM.imgFile(path), wT, hT);
    }
    
    private static BufferedImage getImageNull(int w, int h){
        BufferedImage im = new BufferedImage(w, h, BufferedImage.TYPE_INT_ARGB);
        Graphics2D g = (Graphics2D) im.getGraphics();
        g.setColor(new Color(255,255,255,0));
        g.fillRect(0, 0, im.getWidth(), im.getHeight());
        return im;
    }
    
    public static Color set(int r, int g, int b, int a){
        return new Color(r, g, b, a);
    }
    
    public static Color serR(Color c, int r){
        return set(r, c.getGreen(), c.getBlue(), c.getAlpha());
    }
    public static Color serG(Color c, int g){
        return set(c.getRed(), g, c.getBlue(), c.getAlpha());
    }
    public static Color serB(Color c, int b){
        return set(c.getRed(), c.getGreen(), b, c.getAlpha());
    }
    public static Color serA(Color c, int a){
        return set(c.getRed(), c.getGreen(), c.getBlue(), a);
    }
}
