package app.window;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseWheelListener;

/**
 * @author Death
 */
public class Mouse implements MouseListener, MouseWheelListener, MouseMotionListener{

    public static final int PRESSED = 1, RELEASED = 2;
    
    public static int x, y;
    
    MainPanel panel;

    public Mouse(MainPanel panel){
        this.panel = panel;
        x = 0;
        y = 0;
    }
    
    @Override
    public void mouseClicked(MouseEvent e){
    }

    @Override
    public void mousePressed(MouseEvent e){
        if(panel.game != null) panel.game.mouseLst(e.getButton(), PRESSED);
    }

    @Override
    public void mouseReleased(MouseEvent e){
        if(panel.game != null) panel.game.mouseLst(e.getButton(), RELEASED);
    }

    @Override
    public void mouseEntered(MouseEvent e){
    }

    @Override
    public void mouseExited(MouseEvent e){
    }

    @Override
    public void mouseDragged(MouseEvent e){
        x = e.getX();
        y = e.getY();
    }

    @Override
    public void mouseMoved(MouseEvent e){
        x = e.getX();
        y = e.getY();
    }

    @Override
    public void mouseWheelMoved(MouseWheelEvent e){
        if(panel.game != null) panel.game.wheelMouse(e.getWheelRotation());
    }

}
