package ws.enemy;

import app.SettingApp;
import app.util.SM;
import java.awt.Color;
import java.awt.Graphics2D;
import java.util.ArrayList;
import java.util.HashMap;
import ws.explosion.Explosion;
import ws.explosion.ExplosionSys;
import ws.gameField.GameField;
import ws.obj.Body;
import ws.player.Player;

/**
 * @author Death
 */
public class Enemy extends Body{
    
    public static int MAX_ENEMY = 30;
    
    public static Color 
            color1 = new Color(255, 10, 50),
            color2 = new Color(100, 200, 50),
            color3 = new Color(50, 10, 255);

    public static HashMap<Integer, Enemy> enemyes = new HashMap<>();
    
    public static Enemy e1 = new Enemy().init(1).health(5).damage(1).radius(10).color(color1).speed(5).path(PathEnemy.LINE);
    public static Enemy e2 = new Enemy().init(2).health(10).damage(1).radius(10).color(color2).speed(6).path(PathEnemy.LINE);
    public static Enemy e3 = new Enemy().init(3).health(15).damage(1).radius(10).color(color3).speed(2).path(PathEnemy.RANDOM);
    
    public static Enemy e4 = new Enemy().init(4).health(20).damage(2).radius(15).color(color1).speed(5).path(PathEnemy.LINE);
    public static Enemy e5 = new Enemy().init(5).health(25).damage(2).radius(15).color(color2).speed(6).path(PathEnemy.LINE);
    public static Enemy e6 = new Enemy().init(6).health(30).damage(2).radius(15).color(color3).speed(3).path(PathEnemy.RANDOM);
    
    public static Enemy e7 = new Enemy().init(7).health(35).damage(3).radius(20).color(color1).speed(5).path(PathEnemy.LINE);
    public static Enemy e8 = new Enemy().init(8).health(40).damage(3).radius(20).color(color2).speed(6).path(PathEnemy.LINE);
    public static Enemy e9 = new Enemy().init(9).health(45).damage(3).radius(20).color(color3).speed(4).path(PathEnemy.RANDOM);
    
    public static Enemy e10 = new Enemy().init(10).health(50).damage(5).radius(25).color(color1).speed(5).path(PathEnemy.LINE);
    public static Enemy e11 = new Enemy().init(11).health(60).damage(5).radius(25).color(color2).speed(6).path(PathEnemy.LINE);
    public static Enemy e12 = new Enemy().init(12).health(70).damage(5).radius(25).color(color3).speed(5).path(PathEnemy.RANDOM);
    
    public static Enemy e13 = new Enemy().init(13).health(80).damage(5).radius(30).color(color1).speed(5).path(PathEnemy.LINE);
    public static Enemy e14 = new Enemy().init(14).health(90).damage(5).radius(30).color(color2).speed(6).path(PathEnemy.LINE);
    public static Enemy e15 = new Enemy().init(15).health(100).damage(5).radius(30).color(color3).speed(5).path(PathEnemy.RANDOM);
    
    public static Enemy e16 = new Enemy().init(16).health(110).damage(5).radius(35).color(color1).speed(5).path(PathEnemy.LINE);
    public static Enemy e17 = new Enemy().init(17).health(120).damage(5).radius(35).color(color2).speed(6).path(PathEnemy.LINE);
    public static Enemy e18 = new Enemy().init(18).health(130).damage(5).radius(35).color(color3).speed(6).path(PathEnemy.RANDOM);
    
    public static Enemy e19 = new Enemy().init(19).health(140).damage(5).radius(40).color(color1).speed(5).path(PathEnemy.LINE);
    public static Enemy e20 = new Enemy().init(20).health(150).damage(5).radius(40).color(color2).speed(7).path(PathEnemy.LINE);
    public static Enemy e21 = new Enemy().init(21).health(160).damage(5).radius(40).color(color3).speed(6).path(PathEnemy.RANDOM);
    
    
    public static Enemy e22 = new Enemy().init(22).health(170).damage(6).radius(51).color(null).speed(3).path(PathEnemy.LINE);
    public static Enemy e23 = new Enemy().init(23).health(180).damage(6).radius(52).color(null).speed(3).path(PathEnemy.LINE);
    public static Enemy e24 = new Enemy().init(24).health(190).damage(6).radius(53).color(null).speed(3).path(PathEnemy.RANDOM);
    public static Enemy e25 = new Enemy().init(25).health(200).damage(7).radius(54).color(null).speed(4).path(PathEnemy.LINE);
    public static Enemy e26 = new Enemy().init(26).health(210).damage(7).radius(55).color(null).speed(4).path(PathEnemy.LINE);
    public static Enemy e27 = new Enemy().init(27).health(220).damage(7).radius(56).color(null).speed(5).path(PathEnemy.RANDOM);
    public static Enemy e28 = new Enemy().init(28).health(230).damage(8).radius(57).color(null).speed(5).path(PathEnemy.LINE);
    public static Enemy e29 = new Enemy().init(29).health(240).damage(8).radius(58).color(null).speed(5).path(PathEnemy.LINE);
    public static Enemy e30 = new Enemy().init(30).health(250).damage(8).radius(59).color(null).speed(7).path(PathEnemy.RANDOM);
    
    
    public int id;
    public PathEnemy pathEnemy;
    
    public Enemy(){
        super();
    }
    
    public Enemy init(int id){
        this.id = id;
        
        this.x = SM.random(r, SettingApp.WIDTH - r);
        this.y = - 20;
        
        if(enemyes.get(id) == null){
            enemyes.put(id, this);
        }
        
        invulnerable = false;
        timeExpectationInvulnerable = 20;
        
        return this;
    }
    
    public Enemy health(int i){
        this.healthMax = i;
        this.health = i;
        return this;
    }
    
    public Enemy damage(int i){
        this.damage = i;
        return this;
    }
    
    public Enemy color(Color color){
        if(color != null){
            this.color = color;
        }else{
            this.color = new Color(SM.random(20, 230), SM.random(100, 200), SM.random(20, 230));
        }
        return this;
    }
    
    public Enemy radius(int r){
        this.r = r;
        return this;
    }
    
    public Enemy speed(int i){
        this.speed = i;
        return this;
    }
    
    public Enemy path(int type){
        this.pathEnemy = new PathEnemy(this, type);
        return this;
    }

    @Override
    public void paint(Graphics2D g){
        super.paint(g); //To change body of generated methods, choose Tools | Templates.
        drawHealth(g);
    }
    
    public void removeHealth(int a, EnemyPool pool){
        if(super.removeHealth(a)){
            ExplosionSys.explosions.add(new Explosion(this));
            pool.deathEnemy ++;
            if(GameField.gameField != null){
                GameField.gameField.deathEnemy(pool.deathEnemy);
            }
            pool.remove(this);
        }
    }

    @Override
    public void update(){
        pathEnemy.update();
        super.update();
        updateInvulnerable();
    }
    
    public void collisionPlayer(EnemyPool pool){
        if(GameField.gameField == null) return;
        Player pl = GameField.gameField.player;
        
        if(collisionBody(pl)){
            this.removeHealth(pl.damage, pool);
            pl.removeHealth(damage);
        }
    }
    
    public void remove(ArrayList<Enemy> enemy){
        if(this.y - r*2*2*2 > SettingApp.HEIGHT){
            enemy.remove(this);
        }
    }
    
    public Enemy clone(){
        return new Enemy().init(id)
                .health(healthMax)
                .damage(damage)
                .color(color)
                .radius(r)
                .path(pathEnemy.type)
                .speed(speed);
    }

    
    
}
