package ws.enemy;

import java.awt.Graphics2D;
import java.util.ArrayList;
import ws.player.Bullet;

/**
 * @author Death
 */
public class EnemyPool {

    public ArrayList<Enemy> enemys;
    public int deathEnemy;

    public EnemyPool(){
        deathEnemy = 0;
        enemys = new ArrayList<>();
    }
    
    public void add(Enemy e){
        enemys.add(e);
    }
    
    public void remove(Enemy e){
        enemys.remove(e);
    }
    
    public void draw(Graphics2D g){
        for(int i = 0; i < enemys.size(); i++){
            enemys.get(i).paint(g);
        }
    }
    
    public void update(){
        for(int i = 0; i < enemys.size(); i++){
            enemys.get(i).update();
            enemys.get(i).collisionPlayer(this);
            enemys.get(i).remove(enemys);
        }
    }
    
    public boolean collisionBullet(Bullet b){
        for(int i = 0; i < enemys.size(); i++){
            if(enemys.get(i).collisionBody(b)){
                enemys.get(i).removeHealth(b.damage, this);
                return true;
            }
        }
        return false;
    }
}
