package ws.enemy;

import app.SettingApp;
import app.util.SM;

/**
 * @author Death
 */
public class PathEnemy {

    public static final int 
                LINE = 1,
                RANDOM = 2,
                TYPE2 = 3,
                TYPE3 = 4;
    
    Enemy enemy;
    int type;
    long timeDelay;

    public PathEnemy(Enemy enemy, int type){
        this.enemy = enemy;
        this.type = type;
    }
    
    public void update(){
        if(System.currentTimeMillis() - timeDelay > 1000/50){
            timeDelay = System.currentTimeMillis();
            
            switch(type){
                case LINE: line(); break;
                case RANDOM: random(); break;
            }
        }
        if(enemy.x - enemy.r < 0) enemy.x = 0 + enemy.r;
        if(enemy.x + enemy.r > SettingApp.WIDTH) enemy.x = SettingApp.WIDTH - enemy.r;
    }
    
    private void line(){
        enemy.y += enemy.speed;
    }
    
    private void random(){
        enemy.y += enemy.speed;
        enemy.x += enemy.dx;
        if(SM.random(0, 1000) > 900){
            if(SM.randomBoolean()){
                enemy.dx = -enemy.speed;
            }else{
                enemy.dx = enemy.speed;
            }
        }
    }
    
}
