package ws.explosion;

import java.awt.Color;
import java.awt.Graphics2D;
import ws.obj.Body;

/**
 * @author Death
 */
public class Explosion extends Body{

    long timeDelay;
    int alphaColor;
    
    public Explosion(Body b){
        this.x = b.x;
        this.y = b.y;
        this.r = b.r;
        alphaColor = 200;
        timeDelay = 0;
    }
    
    @Override
    public void paint(Graphics2D g){
        g.setColor(new Color(255, 0, 0, alphaColor));
        g.fillOval(x - r, y - r, r * 2, r * 2);
        
        g.setColor(new Color(255, 0, 0, alphaColor));
        int r1 = r / 3;
        g.fillOval(x - r1, y - r1, r1 * 2, r1 * 2);
        
        g.setColor(new Color(255, 0, 0, alphaColor));
        int r2 = r / 2;
        g.fillOval(x - r2, y - r2, r2 * 2, r2 * 2);
    }

    @Override
    public void update(){
        if(System.currentTimeMillis() - timeDelay > 30){
            timeDelay = System.currentTimeMillis();
            alphaColor -= 4;
            r += 6;
            if(alphaColor < 0) ExplosionSys.explosions.remove(this);
        }
    }
}
