package ws.gameField;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import ws.enemy.EnemyPool;
import ws.explosion.ExplosionSys;
import ws.player.Player;

/**
 * @author Death
 */
public class GameField {

    public static GameField gameField = null;
    
    public GameScreen gameScreen;
    public Player player;
    public EnemyPool enemyPool;
    public GenerateEnemys geneEnemys;

    public GameField(GameScreen gameScreen){
        this.gameScreen = gameScreen;
        player = new Player(this);
        enemyPool = new EnemyPool();
        geneEnemys = new GenerateEnemys(this);
        gameField = this;
    }
    
    public void paint(Graphics2D g){
        ExplosionSys.paint(g);
        player.paint(g);
        enemyPool.draw(g);
        drawInfo(g);
    }
    
    private void drawInfo(Graphics2D g){
        Font f = g.getFont();
        g.setFont(new Font("calibri", 0, 15));
        
        String strDeathEnemy = String.valueOf("Убито врагов: " + enemyPool.deathEnemy);
        String strHealthInfo = String.valueOf("Жизни: " + player.health + "/"+ player.healthMax);
        String strDamage = String.valueOf("Урон: " + player.damageBullet);
        String strRadius = String.valueOf("Радиус игрока: " + player.r);
        String strRadiusBullet = String.valueOf("Радиус пули: " + player.rBullet);
        String strSpeedBullt = String.valueOf("Скорость пули: " + player.speedBullet);
        String exitMenu = String.valueOf("В меню - ESCAPE");
        
        g.setColor(new Color(200, 200, 200));
        g.drawString(strDeathEnemy, 5, (g.getFontMetrics().getHeight() + 5) * 1);
        g.drawString(strHealthInfo, 5, (g.getFontMetrics().getHeight() + 5) * 2);
        g.drawString(strDamage, 5, (g.getFontMetrics().getHeight() + 5) * 3);
        g.drawString(strRadius, 5, (g.getFontMetrics().getHeight() + 5) * 4);
        g.drawString(strRadiusBullet, 5, (g.getFontMetrics().getHeight() + 5) * 5);
        g.drawString(strSpeedBullt, 5, (g.getFontMetrics().getHeight() + 5) * 6);
        g.drawString(exitMenu, 5, (g.getFontMetrics().getHeight() + 5) * 7);
        
        g.setFont(f);
    }

    public void update(){
        ExplosionSys.update();
        player.update();
        enemyPool.update();
        geneEnemys.update();
    }
    
    public void deathEnemy(int i){
        geneEnemys.deathEnemy(i);
        player.deathEnemy(i);
    }

    public void keyLst(int key, int type){
        player.keyLst(key, type);
    }

    public void mouseLst(int key, int type){
        player.mouseLst(key, type);
    }
}
