package ws.menu;

import app.SettingApp;
import app.engine.Screen;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import javax.swing.JButton;
import ws.gameField.GameField;
import ws.gameField.GameScreen;
import ws.setting.SettingScreen;

/**
 * @author Death
 */
public class MenuScreen extends Screen{

    @Override
    public void init(){
        JButton newGame = panelGUI.newButton("<html><b>Новая игра</b></html>");
        newGame.addActionListener((e) -> {
            game.setScreen(new GameScreen());
        });
        
        if(GameField.gameField != null){
            JButton continueGame = panelGUI.newButton("Продолжить");
            continueGame.addActionListener((e) -> {
                game.setScreen(GameField.gameField.gameScreen);
            });
        }
        
        JButton settingGame = panelGUI.newButton("Настройки");
        settingGame.addActionListener((e) -> {
            game.setScreen(new SettingScreen());
        });
        
        JButton exitGame = panelGUI.newButton("Выход");
        exitGame.addActionListener((e) -> {
            System.exit(0);
        });
    }

    @Override
    public void paint(Graphics2D g){
        Font f = g.getFont();
        g.setFont(new Font("calibri", 0, 25));
        String strInfo = String.valueOf("Автор игры Death");
        
        g.setColor(new Color(255, 100, 100));
        g.drawString(strInfo, SettingApp.WIDTH / 2 - g.getFontMetrics().getLeading() * strInfo.length(), SettingApp.HEIGHT - 100);
        
        g.setFont(f);
    }

    @Override
    public void update(){
    }

    @Override
    public void keyLst(int key, int type){
    }

    @Override
    public void mouseLst(int key, int type){
    }

}
