package ws.obj;

import app.util.SM;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics2D;

/**
 * @author Death
 */
public class Body {

    public static final int RECT = 1, ARC = 2;
    
    public static int TYPE_DRAW_HEALTH = RECT;
    public static int ALPHA_COLOR_HEATH = 255;
    
    public int x, y, r, speed;
    public double dx, dy;
    public int damage;
    
    public int health, healthMax;
    
    public Color color;
    
    public boolean invulnerable;
    public long timeExpectationInvulnerable;
    public long timeDelayInvulnerable;
    
    public Body(){
    }

    public void paint(Graphics2D g){
        g.setColor(color);
        g.fillOval(x - r, y - r, r*2, r*2);
        g.setColor(color.darker());
        g.setStroke(new BasicStroke(3));
        g.drawOval(x - r, y - r, r*2, r*2);
        g.setStroke(new BasicStroke(1));
    }

    public void update(){
    }
    
    public boolean removeHealth(int a){
        if(invulnerable)
            return false;
        health -= a;
        if(health <= 0){
            return true;
        }
        timeDelayInvulnerable = System.currentTimeMillis();
        alphaA1 = 100;
        deltaA1 = 20;
        invulnerable = true;
        return false;
    }
    
    private int alphaA1, deltaA1;
    public void updateInvulnerable(){
        if(invulnerable){
            color = SM.serA(color, alphaA1);
            alphaA1 += deltaA1;
            if(alphaA1 > 150) deltaA1 = -deltaA1;
            if(alphaA1 < 50) deltaA1 = -deltaA1;
            if(System.currentTimeMillis() - timeDelayInvulnerable > timeExpectationInvulnerable){
                color = SM.serA(color, 255);
                invulnerable = false;
            }
        }
    }

    public void drawHealth(Graphics2D g){
        if(TYPE_DRAW_HEALTH == ARC) drawHealthArc(g);
        else if(TYPE_DRAW_HEALTH == RECT) drawHealthRect(g);
    }
    private void drawHealthRect(Graphics2D g){
        int w = r * 2 + 15;
        int h = 5;
        int x = this.x - w/ 2;
        int y = this.y - r - 5 - h;
        
        float odPar = w * 0.01F;
        float odPhel = healthMax * 0.01F;
        
        float prozAll = health / odPhel;
        
        int wH = (int)(odPar * prozAll);
        
        
        int alpha = ALPHA_COLOR_HEATH;
        g.setStroke(new BasicStroke(2));
        g.setColor(new Color(100, 100, 200, alpha));
        g.drawRect(x, y, w, h);
        g.setColor(new Color(255, 0, 0, alpha));
        g.fillRect(x, y, w, h);
        g.setColor(new Color(0, 255, 0, alpha));
        g.fillRect(x, y, wH, h);
        g.setStroke(new BasicStroke(1));
    }
    private void drawHealthArc(Graphics2D g){
        float odPar = 360 * 0.01F;
        float odPhel = healthMax * 0.01F;
        
        float prozAll = health / odPhel;
        
        int arH = (int)(odPar * prozAll);
        
        int r = this.r + 6;
        
        int alpha = ALPHA_COLOR_HEATH;
        g.setStroke(new BasicStroke(3));
        g.setColor(new Color(255, 0, 0, alpha));
        g.drawArc(x - r, y - r, r * 2, r * 2, arH, 360 - arH);
        g.setColor(new Color(0, 255, 0, alpha));
        g.drawArc(x - r, y - r, r * 2, r * 2, 0, arH);
        g.setStroke(new BasicStroke(1));
    }
    
    public boolean collisionBody(Body body){
        if(a1(this.x - body.x) + a1(this.y - body.y) < a1(this.r + body.r))
            return true;
        return false;
    }
    
    public int a1(int a){
        return a * a;
    }
}
