package ws.player;

import app.SettingApp;
import java.awt.Color;
import java.awt.Graphics2D;
import ws.obj.Body;

/**
 * @author Death
 */
public class Bullet extends Body{

    Player player;

    long timeDelay;
    
    public Bullet(Player player){
        this.player = player;
        x = player.x;
        y = player.y;
        r = player.rBullet;
        damage = player.damageBullet;
    }
    
    @Override
    public void paint(Graphics2D g){
        g.setColor(new Color(255, 255, 255));
        if(SettingApp.ANTIALIASING){
            g.fillOval(x - player.rBullet, 
                       y - player.rBullet, 
                       player.rBullet * 2, 
                       player.rBullet * 2);
        }else{
            g.fillRect(x - player.rBullet, 
                       y - player.rBullet, 
                       player.rBullet * 2, 
                       player.rBullet * 2);
        }
    }
    
    @Override
    public void update(){
        if(System.currentTimeMillis() - timeDelay > 1000/50){
            timeDelay = System.currentTimeMillis();
            y -= player.speedBullet;
            boolean s = player.gameField.enemyPool.collisionBullet(this);
            if(s) player.bullets.remove(this);
            if(y < -50) player.bullets.remove(this);
        }
    }
}
