package ws.setting;

import app.SettingApp;
import app.engine.Screen;
import app.engine.SettingEngine;
import app.util.SM;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics2D;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JSlider;
import javax.swing.event.AncestorEvent;
import javax.swing.event.AncestorListener;
import ws.menu.MenuScreen;
import ws.obj.Body;
import ws.player.Player;

/**
 * @author Death
 */
public class SettingScreen extends Screen{

    public static final EnemyDemo enemyDemo = new EnemyDemo();
    
    @Override
    public void init(){
        
        JLabel settingGraphics = panelGUI.newLabel("Настройки графики");
        
        JCheckBox checkAntialising = new JCheckBox("Сглаживание", SettingApp.ANTIALIASING);
        checkAntialising.setPreferredSize(new Dimension(SettingEngine.WIDTH_BUTTON, SettingEngine.HEIGHT_BUTTON));
        checkAntialising.setBackground(new Color(0, 0, 0, 0));
        checkAntialising.addActionListener((e) -> {
            SettingApp.ANTIALIASING = checkAntialising.isSelected();
        });
        panelGUI.add(checkAntialising);
        
        
        JCheckBox checkVisibleFPS = new JCheckBox("Отображение FPS", SettingApp.VISIBLE_FPS);
        checkVisibleFPS.setPreferredSize(new Dimension(SettingEngine.WIDTH_BUTTON, SettingEngine.HEIGHT_BUTTON));
        checkVisibleFPS.setBackground(new Color(0, 0, 0, 0));
        checkVisibleFPS.addActionListener((e) -> {
            SettingApp.VISIBLE_FPS = checkVisibleFPS.isSelected();
        });
        panelGUI.add(checkVisibleFPS);
        
        
        JLabel settingHealth = panelGUI.newLabel("Отображения жизней");
        
        JLabel infoTypeHealth = panelGUI.newLabelInfo("Тип жизней:");
       
        JRadioButton arc = new JRadioButton("Круг");
        arc.setPreferredSize(new Dimension(SettingEngine.WIDTH_BUTTON, SettingEngine.HEIGHT_BUTTON));
        arc.setBackground(new Color(0, 0, 0, 0));
        arc.addActionListener((e) -> {
            Body.TYPE_DRAW_HEALTH = Body.ARC;
        });
        panelGUI.add(arc);
        
        JRadioButton rect = new JRadioButton("Прямоугольник");
        rect.setPreferredSize(new Dimension(SettingEngine.WIDTH_BUTTON, SettingEngine.HEIGHT_BUTTON));
        rect.setBackground(new Color(0, 0, 0, 0));
        rect.addActionListener((e) -> {
            Body.TYPE_DRAW_HEALTH = Body.RECT;
        });
        panelGUI.add(rect);
        
        if(Body.ARC == Body.TYPE_DRAW_HEALTH){
            arc.setSelected(true);
        }else if(Body.RECT == Body.TYPE_DRAW_HEALTH){
            rect.setSelected(true);
        }else rect.setSelected(true);
        
        ButtonGroup bg = new ButtonGroup();
        bg.add(arc);
        bg.add(rect);
        
        JLabel infoSlid = panelGUI.newLabelInfo("Прозрачность жизней:");
        
        JSlider slid = new JSlider(JSlider.CENTER, 50, 255, Body.ALPHA_COLOR_HEATH);
        slid.setPreferredSize(new Dimension(SettingEngine.WIDTH_BUTTON, SettingEngine.HEIGHT_BUTTON));
        slid.setBackground(new Color(0, 0, 0, 0));
        slid.addChangeListener((e) -> {
            Body.ALPHA_COLOR_HEATH = slid.getValue();
        });
        panelGUI.add(slid);
        
        
        
        JLabel colorPlayer = panelGUI.newLabel("Цвет игрока");
        
        JLabel RED = panelGUI.newLabelInfo("RED");
        
        JSlider REDC = new JSlider(0, 255, enemyDemo.color.getRed());
        REDC.setPreferredSize(new Dimension(SettingEngine.WIDTH_BUTTON, SettingEngine.HEIGHT_BUTTON));
        REDC.setBackground(new Color(0, 0, 0, 0));
        REDC.addChangeListener((e) -> {
            Player.REDC = REDC.getValue();
            enemyDemo.color = SM.serR(enemyDemo.color, REDC.getValue());
        });
        panelGUI.add(REDC);
        
        JLabel GREEN = panelGUI.newLabelInfo("GREEN");
        
        JSlider GREENC = new JSlider(0, 255, enemyDemo.color.getGreen());
        GREENC.setPreferredSize(new Dimension(SettingEngine.WIDTH_BUTTON, SettingEngine.HEIGHT_BUTTON));
        GREENC.setBackground(new Color(0, 0, 0, 0));
        GREENC.addChangeListener((e) -> {
            Player.GREENC = GREENC.getValue();
            enemyDemo.color = SM.serG(enemyDemo.color, GREENC.getValue());
        });
        panelGUI.add(GREENC);
        
        JLabel BLUE = panelGUI.newLabelInfo("BLUE");
        
        JSlider BLUEC = new JSlider(0, 255, enemyDemo.color.getBlue());
        BLUEC.setPreferredSize(new Dimension(SettingEngine.WIDTH_BUTTON, SettingEngine.HEIGHT_BUTTON));
        BLUEC.setBackground(new Color(0, 0, 0, 0));
        BLUEC.addChangeListener((e) -> {
            Player.BLUEC = BLUEC.getValue();
            enemyDemo.color = SM.serB(enemyDemo.color, BLUEC.getValue());
        });
        panelGUI.add(BLUEC);
        
        JButton back = panelGUI.newButton("Назад");
        back.addActionListener((e) -> {
            game.setScreen(new MenuScreen());
        });
    }

    @Override
    public void paint(Graphics2D g){
        enemyDemo.paint(g);
    }

    @Override
    public void update(){
        enemyDemo.update();
    }

    @Override
    public void keyLst(int key, int type){
    }

    @Override
    public void mouseLst(int key, int type){
    }

}
